VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   1935
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   2880
   LinkTopic       =   "Form1"
   ScaleHeight     =   1935
   ScaleWidth      =   2880
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox picViewport 
      Height          =   1560
      Left            =   120
      ScaleHeight     =   1500
      ScaleWidth      =   1620
      TabIndex        =   1
      Top             =   240
      Width           =   1680
      Begin VB.PictureBox picImage 
         AutoSize        =   -1  'True
         BorderStyle     =   0  'None
         Height          =   3600
         Left            =   0
         Picture         =   "Form1.frx":0000
         ScaleHeight     =   3600
         ScaleWidth      =   4800
         TabIndex        =   2
         Top             =   0
         Width           =   4800
      End
   End
   Begin VB.PictureBox picMap 
      Height          =   780
      Left            =   1920
      ScaleHeight     =   720
      ScaleWidth      =   780
      TabIndex        =   0
      Top             =   240
      Width           =   840
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private m_DraggingBox As Boolean
Private m_StartX As Single
Private m_StartY As Single

' The thickness of the box in the map window.
Private m_MapEdge As Single
' Draw a box showing what part of the picture is visible.
Private Sub DrawBox()
    picMap.Line (-picImage.Left, -picImage.Top)-Step(picViewport.ScaleWidth - m_MapEdge, picViewport.ScaleHeight - picMap.DrawWidth - m_MapEdge), , B
End Sub

Private Sub Form_Load()
    ' Size things.
    picMap.Width = picImage.ScaleWidth / 4 + picMap.Width - picMap.ScaleWidth
    picMap.Height = picImage.ScaleHeight / 4 + picMap.Height - picMap.ScaleHeight
    picViewport.Width = picImage.ScaleWidth / 2 + picMap.Width - picMap.ScaleWidth
    picViewport.Height = picImage.ScaleHeight / 2 + picMap.Height - picMap.ScaleHeight

    picViewport.Move 120, 120
    picMap.Move picViewport.Left + picViewport.Width + 120, 120
    Width = picMap.Left + picMap.Width + 120 + Width - ScaleWidth
    Height = picViewport.Top + picViewport.Height + 120 + Height - ScaleHeight

    picMap.AutoRedraw = True
    picMap.PaintPicture picImage.Picture, _
        0, 0, picMap.ScaleWidth, picMap.ScaleHeight, _
        0, 0, picImage.ScaleWidth, picImage.ScaleHeight
    picMap.DrawMode = vbInvert

    ' Set the thumbnail's coordinates to match the
    ' picture's dimensions.
    picMap.ScaleWidth = picImage.ScaleWidth
    picMap.ScaleHeight = picImage.ScaleHeight

    ' Remember how wide the box's edges are.
    m_MapEdge = picMap.ScaleX(picMap.DrawWidth, vbPixels, picMap.ScaleMode)

    DrawBox
End Sub

' Start dragging the viewing area.
Private Sub picMap_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    ' Make sure the mouse is in the box.
    If X < -picImage.Left Or Y < -picImage.Top Or _
        X > -picImage.Left + picViewport.ScaleWidth - m_MapEdge Or _
        Y > -picImage.Top + picViewport.ScaleHeight - picMap.DrawWidth - m_MapEdge _
            Then Exit Sub

    m_DraggingBox = True

    m_StartX = X
    m_StartY = Y
End Sub

' Continue dragging the viewing area.
Private Sub picMap_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
Dim new_x As Single
Dim new_y As Single

    If Not m_DraggingBox Then Exit Sub

    new_x = picImage.Left + m_StartX - X
    If new_x > 0 Then
        new_x = 0
    ElseIf new_x < -(picImage.Width - picViewport.ScaleWidth) Then
        new_x = -(picImage.Width - picViewport.ScaleWidth)
    End If

    new_y = picImage.Top + m_StartY - Y
    If new_y > 0 Then
        new_y = 0
    ElseIf new_y < -(picImage.Height - picViewport.ScaleHeight) Then
        new_y = -(picImage.Height - picViewport.ScaleHeight)
    End If

    DrawBox
    picImage.Left = new_x
    picImage.Top = new_y
    DrawBox

    m_StartX = X
    m_StartY = Y
End Sub

' Stop dragging the viewing area.
Private Sub picMap_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    m_DraggingBox = False
End Sub


